#include"mqttjson.h"
#include "ip.h"

int keepRunning = 1;
const int gmiddlepwm=0;


// 睡眠毫秒
void sleepms(){
    struct timespec ts;
    ts.tv_sec = 0; // 秒
    ts.tv_nsec = 1000000; // 纳秒，0.5秒等于500,000,000纳秒
    nanosleep(&ts, NULL);
   
}

void sleepmsv2(int val){
    struct timespec ts;
    ts.tv_sec = 0; // 秒
    ts.tv_nsec = val*1000000; // 纳秒，0.5秒等于500,000,000纳秒
    nanosleep(&ts, NULL);
   
}

void *left_function(void *arg)
{ 
    printf("Thread speed is runing\n");
    while(keepRunning){
        sleepmsv2(1);
        gLeftPwmCount++;
        //printf("gLeftPwmCount:%d\n",gLeftPwmCount);
        
        if (gLeftPwmCount>200){
            //printf("mid:%d \n",gmiddlepwm);
            pwmWrite(gLeftPwmPin,gmiddlepwm);  //中间
            // digitalWrite(Pin_left1,LOW);
            // digitalWrite(Pin_left2,LOW);
            gLeftPwmCount = 201;
        } else{
            int pwm1 = gLeftPwm*9;
              //gLeftPwm(0-100)
            pwmWrite(gLeftPwmPin,pwm1);  //0-150-300
            //printf("gLeftPwm:%d,pwm:%d\n",gLeftPwm,pwm1);
        }
    }   
    return NULL; 
}

void *right_function(void *arg)
{ 
     while(keepRunning){
        sleepmsv2(1);
        gRightPwmCount++;
        if (gRightPwmCount>200){
            pwmWrite(gRightPwmPin,gmiddlepwm);  //中间
            gRightPwmCount=2001;
        } else{ 
            int pwm2 = gRightPwm*9;  //gLeftPwm(0-100)          
            pwmWrite(gRightPwmPin,pwm2);  //0-150-300
        }
    }   
    return NULL; 
}




int main(int argc, char *argv[]) {
    struct mosquitto *mosq;
    int rc,ret;
    gStart=time(NULL);
    // 初始化 mosquitto 库
    mosquitto_lib_init();

   
    // 创建 mosquitto 客户端
    mosq = mosquitto_new(CLIENT_ID, true, NULL);
    if (!mosq) {
        fprintf(stderr, "Failed to create mosquitto client\n");
        return EXIT_FAILURE;
    }

    // 设置连接和消息回调
    mosquitto_connect_callback_set(mosq, on_connect);
    mosquitto_message_callback_set(mosq, on_message);

    // 设置用户名和密码
    mosquitto_username_pw_set(mosq, USERNAME, PASSWORD);

    // 连接到 MQTT 代理
    rc = mosquitto_connect(mosq, BROKER_ADDRESS, BROKER_PORT, 60);
    if (rc != MOSQ_ERR_SUCCESS) {
        fprintf(stderr, "Failed to connect to broker: %s\n", mosquitto_strerror(rc));
        mosquitto_destroy(mosq);
        return EXIT_FAILURE;
    }

    ipaddr();
    //printf("%s\n",ip_address);
   mosquitto_publish(mosq, NULL, "controlship/01", strlen(ip_address), ip_address, 0, false);//将ip发送给mqtt

    if (wiringPiSetup()== -1) {
        printf("pin set fail\n");
        return 1;
    }
    
    setinit();
    

    pinMode(gLeftPwmPin,PWM_OUTPUT);
    pwmSetClock(gLeftPwmPin,328);//=19200*1000/(hz*2000)
    pwmSetRange(gLeftPwmPin,1000);

    pinMode(gRightPwmPin,PWM_OUTPUT);
    pwmSetClock(gRightPwmPin,328);//=19200*1000/(hz*2000)
    pwmSetRange(gRightPwmPin,1000);

    pthread_t thread[2];

    if(pthread_create(&thread[0],NULL,left_function,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }

    if(pthread_create(&thread[1],NULL,right_function,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }

    // 开始循环，处理网络流量
    mosquitto_loop_forever(mosq, -1, 1); // -1 表示无限等待，1 表示处理消息的最大数量

    // 清理
    mosquitto_destroy(mosq);
    mosquitto_lib_cleanup(); 
    // 等待线程1结束
    pthread_join(thread[0], NULL);

    // 等待线程2结束
    pthread_join(thread[1], NULL);

        return EXIT_SUCCESS;
}